
/**************************************************************************
**
** Copyright (C) EMC Corporation 2001, All rights reserved.
**
** FILE NAME: ClientFileSysRefPool.h
**
** DESCRIPTION: This is header file to define the class:
**              CClientFileSysRefPool
**
**              This class mainly provide functions to manage the threads
**              to refresh file system.
**              
**
** AUTHOR: Yubing Wang       Jan-16-2001
**
** REVISION HISTORY:
** 
**  Who         Date       Description of Change
** ---------------------------------------------------------------------
**
** (This is only for the major code change that does not include bug fixes.
** Comments for bug fixes should be placed directly where the bugs are.)
**
****************************************************************************
**
**
**  CLASS LIST:
**      CClientFileSysRefPool
**
**
****************************************************************************/

#ifndef _CLIENTFILESYSREFPOOL_H_
#define _CLIENTFILESYSREFPOOL_H_

#include "ClientFileSysRefThread.h"


#define MAX_FILESYSREFNUM       64


class CClientFileSysRefPool
{
private:
    int m_FileSysRefNum;
    CClientFileSysRefThread **m_FileSysRef;

#ifndef WIN32
    pthread_mutex_t m_lock;
    pthread_cond_t m_event;
    int m_IdleNum;
#else
    HANDLE m_lock;
    HANDLE m_hIdleSem;
#endif
    BOOL *m_IsIdle;
    int m_NextIdleID;
	
/* constructor and destructor */
public:
    CClientFileSysRefPool();
    CClientFileSysRefPool(int num, CClientFileSysRefThread **FileSysRef);
    ~CClientFileSysRefPool();

/* operations */
public:
    int GetFileSysRefThreadNum();

    void AddFileSysRefThread(int num, CClientFileSysRefThread **FileSysRef);

    void WairForAllIdle();
    int GetFileSysRefThreadID(CClientFileSysRefThread *pFileSysRef);
    CClientFileSysRefThread *GetFileSysRefThreadByID(int id);

    CClientFileSysRefThread *GetIdleFileSysRefThread();
    void SetIdleFileSysRefThread(int id);
};

#endif

