
/**************************************************************************
**
** Copyright (C) EMC Corporation 2001, All rights reserved.
**
** FILE NAME: ConfigFile.cpp
**
** DESCRIPTION: This class mainly manager config file.
**              
**
** AUTHOR: Yubing Wang       Mar-01-2002
**
** REVISION HISTORY:
** 
**  Who         Date       Description of Change
** ---------------------------------------------------------------------
**
** (This is only for the major code change that does not include bug fixes.
** Comments for bug fixes should be placed directly where the bugs are.)
**
****************************************************************************
**
**
** FUNCTION LIST:
**     CConfigFile::CConfigFile()
**     CConfigFile::~CConfigFile()
**
**
****************************************************************************/


#include "ConfigFile.h"

int UNIX_OPMIX_ARGS[] = 
{
    OPMIX_ARG_Read,
    OPMIX_ARG_OverWrite,
    OPMIX_ARG_Append,
    OPMIX_ARG_Truncate,
    OPMIX_ARG_Stat,
    OPMIX_ARG_Chmod,
    OPMIX_ARG_CreatNULL,
    OPMIX_ARG_Mkdir,
    OPMIX_ARG_Rmdir,
    OPMIX_ARG_ReadDir,
    OPMIX_ARG_Symlink,
    OPMIX_ARG_Readlink,
    OPMIX_ARG_Link,
    OPMIX_ARG_Unlink,
    OPMIX_ARG_Rename,
    OPMIX_ARG_Statvfs,
    OPMIX_ARG_Memmap,
};

int WIN_OPMIX_ARGS[] = 
{
    OPMIX_ARG_Read,
    OPMIX_ARG_OverWrite,
    OPMIX_ARG_Append,
    OPMIX_ARG_Truncate,
    OPMIX_ARG_GetAttr,
    OPMIX_ARG_SetAttr,
    OPMIX_ARG_CreatNULL,
    OPMIX_ARG_Mkdir,
    OPMIX_ARG_Rmdir,
    OPMIX_ARG_ReadDir,
    OPMIX_ARG_Rename,
    OPMIX_ARG_Delete,
    OPMIX_ARG_GetDiskSpace,
};

CConfigFile::CConfigFile()
{
    init_arguments();
}

CConfigFile::~CConfigFile()
{
    free_arguments();
}

/* functions to manage arguments */
void CConfigFile::init_arguments()
{
    /* init config_args */
    strcpy(config_args[CONFIG_ARG_PRIM_NAME].name, "PRIM_NAME");
    config_args[CONFIG_ARG_PRIM_NAME].value = NULL;

    strcpy(config_args[CONFIG_ARG_PRIM_IP].name, "PRIM_IP");
    config_args[CONFIG_ARG_PRIM_IP].value = NULL;

    strcpy(config_args[CONFIG_ARG_LOAD_NAME].name, "LOAD_NAME");
    config_args[CONFIG_ARG_LOAD_NAME].value = NULL;

    strcpy(config_args[CONFIG_ARG_LOAD_IP].name, "LOAD_IP");
    config_args[CONFIG_ARG_LOAD_IP].value = NULL;

    strcpy(config_args[CONFIG_ARG_STRESS_SERVER].name, "STRESS_SERVER");
    config_args[CONFIG_ARG_STRESS_SERVER].value = NULL;

    strcpy(config_args[CONFIG_ARG_LOAD_LEVEL].name, "LOAD_LEVEL");
    config_args[CONFIG_ARG_LOAD_LEVEL].value = NULL;

    strcpy(config_args[CONFIG_ARG_RUN_TIME].name, "RUN_TIME");
    config_args[CONFIG_ARG_RUN_TIME].value = NULL;

    strcpy(config_args[CONFIG_ARG_PROTOCOL].name, "PROTOCOL");
    config_args[CONFIG_ARG_PROTOCOL].value = NULL;

    strcpy(config_args[CONFIG_ARG_SERVER_NAME].name, "SERVER_NAME");
    config_args[CONFIG_ARG_SERVER_NAME].value = NULL;

    strcpy(config_args[CONFIG_ARG_FS_MNT_POINT].name, "FS_MNT_POINT");
    config_args[CONFIG_ARG_FS_MNT_POINT].value = NULL;

    strcpy(config_args[CONFIG_ARG_FS_SIZE].name, "FS_SIZE");
    config_args[CONFIG_ARG_FS_SIZE].value = NULL;

    strcpy(config_args[CONFIG_ARG_THREAD_NUM].name, "THREAD_NUM");
    config_args[CONFIG_ARG_THREAD_NUM].value = NULL;

    strcpy(config_args[CONFIG_ARG_OPMIX_FILE].name, "OPMIX_FILE");
    config_args[CONFIG_ARG_OPMIX_FILE].value = NULL;

    /* init opmix_args */
    strcpy(opmix_args[OPMIX_ARG_Read].name, "Read");
    opmix_args[OPMIX_ARG_Read].value = NULL;

    strcpy(opmix_args[OPMIX_ARG_OverWrite].name, "OverWrite");
    opmix_args[OPMIX_ARG_OverWrite].value = NULL;

    strcpy(opmix_args[OPMIX_ARG_Append].name, "Append");
    opmix_args[OPMIX_ARG_Append].value = NULL;

    strcpy(opmix_args[OPMIX_ARG_Truncate].name, "Truncate");
    opmix_args[OPMIX_ARG_Truncate].value = NULL;

    strcpy(opmix_args[OPMIX_ARG_Stat].name, "Stat");
    opmix_args[OPMIX_ARG_Stat].value = NULL;

    strcpy(opmix_args[OPMIX_ARG_Chmod].name, "Chmod");
    opmix_args[OPMIX_ARG_Chmod].value = NULL;

    strcpy(opmix_args[OPMIX_ARG_CreatNULL].name, "CreatNULL");
    opmix_args[OPMIX_ARG_CreatNULL].value = NULL;

    strcpy(opmix_args[OPMIX_ARG_Mkdir].name, "Mkdir");
    opmix_args[OPMIX_ARG_Mkdir].value = NULL;

    strcpy(opmix_args[OPMIX_ARG_Rmdir].name, "Rmdir");
    opmix_args[OPMIX_ARG_Rmdir].value = NULL;

    strcpy(opmix_args[OPMIX_ARG_ReadDir].name, "ReadDir");
    opmix_args[OPMIX_ARG_ReadDir].value = NULL;

    strcpy(opmix_args[OPMIX_ARG_Symlink].name, "Symlink");
    opmix_args[OPMIX_ARG_Symlink].value = NULL;

    strcpy(opmix_args[OPMIX_ARG_Readlink].name, "Readlink");
    opmix_args[OPMIX_ARG_Readlink].value = NULL;

    strcpy(opmix_args[OPMIX_ARG_Link].name, "Link");
    opmix_args[OPMIX_ARG_Link].value = NULL;

    strcpy(opmix_args[OPMIX_ARG_Unlink].name, "Unlink");
    opmix_args[OPMIX_ARG_Unlink].value = NULL;

    strcpy(opmix_args[OPMIX_ARG_Rename].name, "Rename");
    opmix_args[OPMIX_ARG_Rename].value = NULL;

    strcpy(opmix_args[OPMIX_ARG_Statvfs].name, "Statvfs");
    opmix_args[OPMIX_ARG_Statvfs].value = NULL;

    strcpy(opmix_args[OPMIX_ARG_Memmap].name, "Memmap");
    opmix_args[OPMIX_ARG_Memmap].value = NULL;

    strcpy(opmix_args[OPMIX_ARG_GetAttr].name, "GetAttr");
    opmix_args[OPMIX_ARG_GetAttr].value = NULL;

    strcpy(opmix_args[OPMIX_ARG_SetAttr].name, "SetAttr");
    opmix_args[OPMIX_ARG_SetAttr].value = NULL;

    strcpy(opmix_args[OPMIX_ARG_Delete].name, "Delete");
    opmix_args[OPMIX_ARG_Delete].value = NULL;

    strcpy(opmix_args[OPMIX_ARG_GetDiskSpace].name, "GetDiskSpace");
    opmix_args[OPMIX_ARG_GetDiskSpace].value = NULL;
}

void CConfigFile::free_arguments()
{
    int i;

    for (i=0; i<CONFIG_ARG_NUMBER; i++)
    {
        if (config_args[i].value != NULL)
            free(config_args[i].value);
    }

    for (i=0; i<OPMIX_ARG_GetDiskSpace; i++)
    {
        if (opmix_args[i].value != NULL)
            free(opmix_args[i].value);
    }
}

BOOL CConfigFile::read_arguments(char *file_name, int args_num, ARG_TYPE args[], char *error_msg)
{
    FILE *fp;
    char line[2048];
    int starti, length;

    fp = fopen(file_name, "r");
    if (fp == NULL)
    {
        sprintf(error_msg, "File (%s) not found", file_name);
        return FALSE;
    }
    int line_no = 0;
    while ( fgets_unix(line, 2048, fp) )
    {
        line_no ++;
        length = strlen(line);
        for (starti=0; starti<length; starti++)
        {
            if (line[starti] != ' ' && line[starti] != '\t' && line[starti] != 0x0a)
                break;
        }
        if (starti == length)
            continue;
        if (line[starti] == '#')   // recomment
            continue;

        if (! read_one(line+starti, args_num, args))      // error
        {
            sprintf(error_msg, "File (%s) format error at line %d", file_name, line_no);
            fclose(fp);
            return FALSE;
        }
    }

    fclose(fp);
    return TRUE;
}

// rewrite fgets function to read the unix format text file in dos enviroment
char *CConfigFile::fgets_unix(char *string, int n, FILE *stream)
{
    int i, c;

    i = 0;
    while ( i < n )
    {
        c = fgetc(stream);
        if (c == 0x0d)
            continue;   // continue to read next one: 0x0a
        if (c != 0x0a && c != EOF)
            string[i ++] = c;
        else
        {
            string[i] = 0;
            break;
        }
    }
    if (i == 0 && c == EOF)
        return NULL;
    else
        return string;
}

BOOL CConfigFile::read_one(char *line, int args_num, ARG_TYPE args[])
{
    char *p, *name, *value;
    int i, arg_index;

    p = strchr(line, '=');
    if (p == NULL)             // no '=' mark
        return FALSE;

    name = line;
    value = p + 1;
    *p = 0;

    while (*name != '\0')
    {
        if (*name != ' ' && *name != '\t' && *name != 0x0a)
            break;
        name ++;
    }
    if (*name == '\0')
        return FALSE;
    for (i=strlen(name)-1; i>=0; i--)
    {
        if (name[i] != ' ' && name[i] != '\t' && name[i] != 0x0a)
            break;
    }
    if (i < 0)
        return FALSE;
    name[i+1] = '\0';

    for (arg_index=0; arg_index<args_num; arg_index++)
    {
        if (strcmp(args[arg_index].name, name) == 0)
            break;
    }
    if (arg_index == args_num)  // no argument name matched
        return FALSE;


    while (*value != '\0')
    {
        if (*value != ' ' && *value != '\t' && *value != 0x0a)
            break;
        value ++;
    }
    if (*value == '\0')
    {
        resign_value(arg_index, args, NULL);
        return TRUE;
    }

    for (i=strlen(value)-1; i>=0; i--)
    {
        if (value[i] != ' ' && value[i] != '\t' && value[i] != 0x0a)
            break;
    }
    if (i < 0)
    {
        resign_value(arg_index, args, NULL);
        return TRUE;
    }
    value[i+1] = 0;

    if (value[0] == '\"')
    {
        p = strchr(value+1, '\"');
        if (p == NULL)
            return FALSE;
        *p = 0;
        resign_value(arg_index, args, value+1);
    }
    else
        resign_value(arg_index, args, value);

    return TRUE;
}

void CConfigFile::resign_value(int arg_index, ARG_TYPE args[], char *value)
{
    if (args[arg_index].value != NULL)
        free(args[arg_index].value);
    if (value == NULL || value[0] == '\0')
        args[arg_index].value = NULL;
    else
        args[arg_index].value = _STRDUP(value);
}

/* fucntions to manage prim client config file */
BOOL CConfigFile::ReadFromFile(char *file_name, char *error_msg)
{
    if (! read_arguments(file_name, CONFIG_ARG_NUMBER, config_args, error_msg))
        return FALSE;

    if (! GetConfigPara(error_msg))
        return FALSE;

    char *opmix_file = config_args[CONFIG_ARG_OPMIX_FILE].value;
    if (opmix_file == NULL || opmix_file[0] == '\0')
        SetDefaultOpmix();
    else
    {
        if (! read_arguments(opmix_file, OPMIX_ARG_NUMBER, opmix_args, error_msg))
            return FALSE;

        if (! GetOpmix(error_msg))
            return FALSE;
    }

    return TRUE;
}

BOOL CConfigFile::GetConfigPara(char *error_msg)
{
    char *value;
    char sep[4];
    char *p;
    int i;

    // prim name
    if (config_args[CONFIG_ARG_PRIM_NAME].value == NULL)
    {
        sprintf(error_msg, "Config file format error: basic parameter %s not defined", config_args[CONFIG_ARG_PRIM_NAME].name);
        return FALSE;
    }
    else 
        strcpy(m_primname, config_args[CONFIG_ARG_PRIM_NAME].value);

    // prim ip
    if (config_args[CONFIG_ARG_PRIM_IP].value == NULL)
    {
        sprintf(error_msg, "Config file format error: basic parameter %s not defined", config_args[CONFIG_ARG_PRIM_IP].name);
        return FALSE;
    }
    else 
        strcpy(m_primip, config_args[CONFIG_ARG_PRIM_IP].value);

    // load names
    int load_name_num = 0;
    if (config_args[CONFIG_ARG_LOAD_NAME].value == NULL)
    {
        sprintf(error_msg, "Config file format error: basic parameter %s not defined", config_args[CONFIG_ARG_LOAD_NAME].name);
        return FALSE;
    }
    else 
    {
        strcpy(sep, " \t");
        value = strtok(config_args[CONFIG_ARG_LOAD_NAME].value, sep);
        while ( value != NULL )
        {
            if (strlen(value) >= MAX_NAMELEN)
            {
                sprintf(error_msg, "Config file format error: string (%s) too long", config_args[CONFIG_ARG_LOAD_NAME].name);
                return FALSE;
            }
            else if (load_name_num >= MAX_CLIENT_NUM)
            {
                sprintf(error_msg, "Config file format error: (%s) too many load names", config_args[CONFIG_ARG_LOAD_NAME].name);
                return FALSE;
            }
            strcpy(m_clients[load_name_num ++], value);
            value = strtok(NULL, sep);
        }
    }

    // load ips
    int load_ip_num = 0;
    if (config_args[CONFIG_ARG_LOAD_IP].value == NULL)
    {
        sprintf(error_msg, "Config file format error: basic parameter %s not defined", config_args[CONFIG_ARG_LOAD_IP].name);
        return FALSE;
    }
    else 
    {
        strcpy(sep, " \t");
        value = strtok(config_args[CONFIG_ARG_LOAD_IP].value, sep);
        while ( value != NULL )
        {
            if (strlen(value) >= MAX_IPADDRLEN)
            {
                sprintf(error_msg, "Config file format error: string (%s) too long", config_args[CONFIG_ARG_LOAD_IP].name);
                return FALSE;
            }
            else if (load_ip_num >= MAX_CLIENT_NUM)
            {
                sprintf(error_msg, "Config file format error: (%s) too many load ips", config_args[CONFIG_ARG_LOAD_IP].name);
                return FALSE;
            }
            strcpy(m_client_ips[load_ip_num ++], value);
            value = strtok(NULL, sep);
        }
    }

    if (load_name_num != load_ip_num)
    {
        sprintf(error_msg, "Config file format error: (%s) (%s) different number", config_args[CONFIG_ARG_LOAD_NAME].name, config_args[CONFIG_ARG_LOAD_IP].name);
        return FALSE;
    }
    else
        m_client_num = load_name_num;

    // stress server
    value = config_args[CONFIG_ARG_STRESS_SERVER].value;
    if (value == NULL)
    {
        sprintf(error_msg, "Config file format error: basic parameter %s not defined", config_args[CONFIG_ARG_STRESS_SERVER].name);
        return FALSE;
    }
    else if (strcmp(value, "0") != 0 && strcmp(value, "1") != 0)
    {
        sprintf(error_msg, "Config file format error: basic parameter %s should be 0 or 1", config_args[CONFIG_ARG_STRESS_SERVER].name);
        return FALSE;
    }
    else 
        m_stress_server = atoi(value);

    // load level
    if (config_args[CONFIG_ARG_LOAD_LEVEL].value == NULL)
    {
        if (! m_stress_server)
        {
            sprintf(error_msg, "Config file format error: basic parameter %s not defined", config_args[CONFIG_ARG_LOAD_LEVEL].name);
            return FALSE;
        }
        else
        {
            for (i=0; i<m_client_num; i++)
                m_load[i] = 200;
        }
    }
    else 
    {
        int load_level = atoi(config_args[CONFIG_ARG_LOAD_LEVEL].value);
        if (load_level < m_client_num)
        {
            sprintf(error_msg, "Config file format error: (%s) too few load level", config_args[CONFIG_ARG_LOAD_LEVEL].name);
            return FALSE;
        }
        for (i=0; i<m_client_num; i++)
            m_load[i] = load_level / m_client_num;
    }

    // run time
    value = config_args[CONFIG_ARG_RUN_TIME].value;
    if (value == NULL || atoi(value) <= 0)
    {
        sprintf(error_msg, "Config file format error: basic parameter %s not defined", config_args[CONFIG_ARG_RUN_TIME].name);
        return FALSE;
    }
    else 
        m_run_time = atoi(value);

    // protocol
    value = config_args[CONFIG_ARG_PROTOCOL].value;
    if (value == NULL)
    {
        sprintf(error_msg, "Config file format error: basic parameter %s not defined", config_args[CONFIG_ARG_PROTOCOL].name);
        return FALSE;
    }
    else if (strcmp(value, "NFS") != 0 && strcmp(value, "CIFS") != 0)
    {
        sprintf(error_msg, "Config file format error: (%s) should be NFS or CIFS", config_args[CONFIG_ARG_PROTOCOL].name);
        return FALSE;
    }
    else
    {
        m_ostype = (strcmp(value, "NFS") == 0) ? OSTYPE_UNIX : OSTYPE_WIN;
    }

    // server name
    if (config_args[CONFIG_ARG_SERVER_NAME].value == NULL)
    {
        sprintf(error_msg, "Config file format error: basic parameter %s not defined", config_args[CONFIG_ARG_SERVER_NAME].name);
        return FALSE;
    }
    else 
        strcpy(m_ServerName, config_args[CONFIG_ARG_SERVER_NAME].value);

    // file system mount point
    m_fs_num = 0;
    if (config_args[CONFIG_ARG_FS_MNT_POINT].value == NULL)
    {
        sprintf(error_msg, "Config file format error: basic parameter %s not defined", config_args[CONFIG_ARG_FS_MNT_POINT].name);
        return FALSE;
    }
    else
    {
        strcpy(sep, " \t");
        value = strtok(config_args[CONFIG_ARG_FS_MNT_POINT].value, sep);
        while ( value != NULL )
        {
            if (m_fs_num >= MAX_FSNUM)
            {
                sprintf(error_msg, "Config file format error: (%s) too many file systems", config_args[CONFIG_ARG_FS_MNT_POINT].name);
                return FALSE;
            }

            if (m_ostype == OSTYPE_UNIX)
            {
                p = strchr(value, ':');
                if (p == NULL)
                {
                    sprintf(error_msg, "Config file format error: (%s) %s not valid mount point", config_args[CONFIG_ARG_FS_MNT_POINT].name, value);
                    return FALSE;
                }
                *p = 0;
                if (strlen(value) >= MAX_NAMELEN || strlen(p+1) >= MAX_PATHLEN)
                {
                    sprintf(error_msg, "Config file format error: string (%s) too long", config_args[CONFIG_ARG_FS_MNT_POINT].name);
                    return FALSE;
                }
                strcpy(m_FsName[m_fs_num], p+2);
                strcpy(m_ServerNetIF[m_fs_num], value);
                strcpy(m_ServerPath[m_fs_num], p+1);
                strcpy(m_ShareName[m_fs_num], "");
            }
            else
            {
                if (strncmp(value, "\\\\", 2) != 0 || (p = strchr(value+2, '\\')) == NULL)
                {
                    sprintf(error_msg, "Config file format error: (%s) %s not valid mount point", config_args[CONFIG_ARG_FS_MNT_POINT].name, value);
                    return FALSE;
                }
                *p = 0;
                if (strlen(value+2) >= MAX_NAMELEN || strlen(p+1) >= MAX_PATHLEN)
                {
                    sprintf(error_msg, "Config file format error: string (%s) too long", config_args[CONFIG_ARG_FS_MNT_POINT].name);
                    return FALSE;
                }
                strcpy(m_FsName[m_fs_num], p+1);
                strcpy(m_ServerNetIF[m_fs_num], value+2);
                strcpy(m_ServerPath[m_fs_num], "");
                strcpy(m_ShareName[m_fs_num], p+1);
            }

            m_fs_num ++;
            value = strtok(NULL, sep);
        }
    }

    // file set size (small, medium, large)
    int fssize_num = 0;
    if (config_args[CONFIG_ARG_FS_SIZE].value == NULL)
    {
        sprintf(error_msg, "Config file format error: basic parameter %s not defined", config_args[CONFIG_ARG_FS_SIZE].name);
        return FALSE;
    }
    else
    {
        strcpy(sep, " \t");
        value = strtok(config_args[CONFIG_ARG_FS_SIZE].value, sep);
        while ( value != NULL )
        {
            if (fssize_num >= MAX_FSNUM)
            {
                sprintf(error_msg, "Config file format error: (%s) too many file set sizes", config_args[CONFIG_ARG_FS_SIZE].name);
                return FALSE;
            }

            if (strcmp(value, "small") == 0)
                m_FsSize[fssize_num] = 0;
            else if (strcmp(value, "medium") == 0)
                m_FsSize[fssize_num] = 1;
            else if (strcmp(value, "large") == 0)
                m_FsSize[fssize_num] = 2;
            else
            {
                sprintf(error_msg, "Config file format error: (%s) %s not valid file set size", config_args[CONFIG_ARG_FS_SIZE].name, value);
                return FALSE;
            }

            fssize_num ++;
            value = strtok(NULL, sep);
        }

        if (fssize_num != m_fs_num)
        {
            sprintf(error_msg, "Config file format error: (%s) (%s) different number", config_args[CONFIG_ARG_FS_MNT_POINT].name, config_args[CONFIG_ARG_FS_SIZE].name);
            return FALSE;
        }
    }

    // thread number
    if (config_args[CONFIG_ARG_THREAD_NUM].value != NULL)
    {
        m_thread_num = atoi(config_args[CONFIG_ARG_THREAD_NUM].value);
        if (m_thread_num <= 0)
        {
            sprintf(error_msg, "Config file format error: basic parameter %s not defined", config_args[CONFIG_ARG_THREAD_NUM].name);
            return FALSE;
        }
    }
    else 
        m_thread_num = (m_ostype == OSTYPE_UNIX) ? 16 : 8;

    return TRUE;
}

void CConfigFile::SetDefaultOpmix()
{
    if (m_ostype == OSTYPE_UNIX)
    {
        m_opmix[0] = 20;
        m_opmix[1] = 20,
        m_opmix[2] = 7;
        m_opmix[3] = 4;
        m_opmix[4] = 5;
        m_opmix[5] = 5;
        m_opmix[6] = 5;
        m_opmix[7] = 5;
        m_opmix[8] = 5;
        m_opmix[9] = 5;
        m_opmix[10] = 2;
        m_opmix[11] = 2;
        m_opmix[12] = 2;
        m_opmix[13] = 2;
        m_opmix[14] = 5;
        m_opmix[15] = 5;
        m_opmix[16] = 1;
    }
    else
    {
        m_opmix[0] = 20;
        m_opmix[1] = 20;
        m_opmix[2] = 7; 
        m_opmix[3] = 4; 
        m_opmix[4] = 10;
        m_opmix[5] = 10;
        m_opmix[6] = 5; 
        m_opmix[7] = 5; 
        m_opmix[8] = 5; 
        m_opmix[9] = 4; 
        m_opmix[10] = 4;
        m_opmix[11] = 5;
        m_opmix[12] = 1;
    }
}


BOOL CConfigFile::GetOpmix(char *error_msg)
{
    int args_num;
    int *args_index;
    int i, index;
    int summary;

    if (m_ostype == OSTYPE_UNIX)
    {
        args_num = sizeof(UNIX_OPMIX_ARGS) / sizeof(int);
        args_index = UNIX_OPMIX_ARGS;
    }
    else
    {
        args_num = sizeof(WIN_OPMIX_ARGS) / sizeof(int);
        args_index = WIN_OPMIX_ARGS;
    }

    for (i=0; i<args_num; i++)
    {
        index = args_index[i];
        if (opmix_args[index].value == NULL)
        {
            sprintf(error_msg, "Opmix file format error: operation %s not defined", opmix_args[index].name);
            return FALSE;
        }
        m_opmix[i] = atoi(opmix_args[index].value);
        if (m_opmix[i] < 0 || m_opmix[i] > 100)
        {
            sprintf(error_msg, "Opmix file format error: percentage of %s should be between 0 and 100", opmix_args[index].name);
            return FALSE;
        }
    }

    summary = 0;
    for (i=0; i<args_num; i++)
        summary += m_opmix[i];
    if (summary != 100)
    {
        sprintf(error_msg, "Opmix file format error: summary of all percentages should equal 100");
        return FALSE;
    }

    return TRUE;
}

