
/**************************************************************************
**
** Copyright (C) EMC Corporation 2001, All rights reserved.
**
** FILE NAME: SafeFileOperation.h
**
** DESCRIPTION: This is header file to define the class:
**              CSafeFileOperation
**
**              This class defines a group of file operation to initialize 
**              file system.
**              
**
** AUTHOR: Yubing Wang       Mar-03-2001
**
** REVISION HISTORY:
** 
**  Who         Date       Description of Change
** ---------------------------------------------------------------------
**
** (This is only for the major code change that does not include bug fixes.
** Comments for bug fixes should be placed directly where the bugs are.)
**
****************************************************************************
**
**
**  CLASS LIST:
**      CSafeFileOperation
**
**
****************************************************************************/

#ifndef _SAFEFILEOPERATION_H_
#define _SAFEFILEOPERATION_H_

class CSafeFileOperation
{
/* operations */
public:
    /* return value: 0-Fail  1-File exists  2-File doesn't exist */
    /* if size is not NULL, filled by file size; if mode is not NULL, filled by file mode */
    static int Lookup(char *name, int *size, int *mode);

    static BOOL Chmod(char *name, ushort mode);
    static BOOL CreateNull(char *name, ushort &mode);
    static BOOL Remove(char *name);
    static BOOL Mkdir(char *name);
    static BOOL Rmdir(char *name);
    static BOOL EmptyDir(char *name);
    static BOOL Symlink(char *name, char *target);
    static BOOL CreateWrite(char *name, int size);
    static BOOL Append(char *name, int size);
    static BOOL SetNull(char *name);
    static BOOL Truncate(char *name, int size);

    static BOOL RemoveAny(char *name);

    static BOOL CheckWritePermission(char *name);
};

#endif
